(function(window) {


	/*
	####  ##    ##   ####  ########   
	 ##   ###   ##    ##      ##      
	 ##   ####  ##    ##      ##      
	 ##   ## ## ##    ##      ##      
	 ##   ##  ####    ##      ##      
	 ##   ##   ###    ##      ##      
	####  ##    ##   ####     ##      
	*/



	
	$(document).bind('drop dragover', function(e) {
		e.preventDefault();
		e.stopPropagation();
	});

	document.addEventListener('dragstart', function(e) {
		e.dataTransfer.effectAllowed = "copyMove";
	}, false);

	
	// show wisdom
	// _settings.show_wisdom_on_startup && wisdom.showWisdom();
	wisdom.showWisdom();

	// run plugins
	plugins.runInstalledPlugins();

	



	// set jumps
	jumps.createListBox();
	$('#jumps_list').css("display", "none");

	// init universal pane
	universalPane._init();


	_editor.loadCustomDictionary();




	/*
	########   ##    ##   ########        ####  ##    ##   ####  ########   
	##         ###   ##   ##     ##        ##   ###   ##    ##      ##      
	##         ####  ##   ##     ##        ##   ####  ##    ##      ##      
	######     ## ## ##   ##     ##        ##   ## ## ##    ##      ##      
	##         ##  ####   ##     ##        ##   ##  ####    ##      ##      
	##         ##   ###   ##     ##        ##   ##   ###    ##      ##      
	########   ##    ##   ########        ####  ##    ##   ####     ##      
	*/





	$("#info_bar_top").on("contextmenu", function(e) {
		e.preventDefault();

		var posX = e.clientX - this.offsetLeft;
		var width = $("#info_bar_top").width();


		if (posX <= 35) {
			commandPalette.showCommandPalette(storage.getDocumentsPaletteItems(), {isRoot: true});
		} else if (posX > 35 && posX <= 70) {
			commandPalette.showCommandPalette(jumps.getJumpsPaletteItems(), {isRoot: true});
		} else if (posX >= width - 35) {
			commandPalette.showCommandPalette(repository.getRepoPaletteItems(), {isRoot: true});
		} else {
			commandPalette.showCommandPalette();
		}
	});


	var records = [

	{
			"id": "pb0",
			"html": '<strong>Documents</strong>',
			"value": "some value",
			"items": [
				{
					"id": "p1",
					"html": '<span class="awf">&#xf01c;</span> All',
					"value": "some value"
				}, 

				// {
				// 	"id": "p4",
				// 	"html": '<span class="awf">&#xf017;</span> Today',
				// 	"value": "some value"
				// },

				{
					"id": "p4",
					"html": '<span class="awf">&#xf017;</span> Last opened',
					"value": "some value"
				},

				{
					"id": "p2",
					"html": '<span class="awf">&#xf0c1;</span> Files',
					"value": "some value"
				}, 

				{
					"id": "p3",
					"html": '<span class="awf">&#xf005;</span> Favorites',
					"value": "some value"
				},

				{
					"id": "p8",
					"html": '<span class="awf">&#xf002;</span> Search',
					"value": "some value"
				},


				{
					"id": "p5",
					"html": '<span class="awf">&#xf1b8;</span> Trash',
					"value": "some value"
				}
			],
			"expanded": true
		}, 
		{
			"id": "pb6",
			"value": "some value",
			"html": '<strong>Projects</strong>',
			"expanded": true
		}

	];



	$('#sources_list').jqxTree({
		theme: "metro",
		source: records,
		allowDrag: false,
		allowDrop: true,
		enableHover: true,
		incrementalSearch: false,
		width: '100%'
	});


	// custom scrolling for windows and linux
	// if (os.platform() != 'darwin')
	$('#sources_list_container').perfectScrollbar();


	// $("#fulltext_search_input").on('keyup', function(e) {
	// 	if (e.keyCode == 13) {
	// 		storage.doFullTextSearch($("#fulltext_search_input").val());
	// 	}
	// });




	$('#sources_list').on('select', function(event) {

		if (event.args.element.id != 'p8') 
			$('#doc_search_input').val('');

		if (event.args.element.id.startsWith('pb')) { // blank is selected
			return;
		} else if (!event.args.element.id.startsWith('p')) { // project is selected
			storage.setProject(parseInt(event.args.element.id));
			return;
		} 

		_currentProjectId = -1;
		localStorage['PROJECTS_CURRENT_PROJECT_ID'] = -1;

		
		if (event.args.element.id == "p5")
			storage.setDocumentList({
				del: true
			});

		else if (event.args.element.id == "p1")
			storage.setDocumentList({
				del: false
			});
		else if (event.args.element.id == "p2")
			storage.setDocumentList({
				del: false,
				pth: { $ne: "" }
			});
		else if (event.args.element.id == "p3")
			storage.setDocumentList({
				del: false,
				fav: true
			});
		else if (event.args.element.id == "p4")
			storage.setDocumentList({
				del: false,
				_id: {$in: JSON.parse(localStorage['DOCUMENTS_RECENT_DOCS'])}
			}, {});
		else if (event.args.element.id == "p8") {		
			if ($('#doc_search_input').val() == '') {
				
				$('#doc_search_input').focus();
				
				if (localStorage['SEARCH_LAST_ITEMS']) {
					$('#doc_search_input').val(storage.getLastSearchesArray()[0]);
					
					storage.doFullTextSearch(storage.getLastSearchesArray()[0]);
				}
			}
		}
	});


	$("#doc_list").on('dragEnd', function(event) {

		var ev = event.args.originalEvent;
		var x = ev.pageX;
		var y = ev.pageY;
		var ht = $('#sources_list').jqxTree('hitTest', x, y);

		if (ht == null || ht.element.id.startsWith("p"))
			return false;
		
		storage.assignDocumentToProject(event);

	});


	// set project
	if (localStorage['PROJECTS_CURRENT_PROJECT_ID'])
		_currentProjectId = parseInt(localStorage['PROJECTS_CURRENT_PROJECT_ID']);
	

	storage.setProjectsTree(function() {

		//$('#sources_list').jqxTree('selectItem', $('#sources_list li')[1]);
		// storage.setDocumentList();

		if (_currentProjectId == -1 || !_currentProjectsList[_currentProjectId.toString()]) {
			$('#sources_list').jqxTree('selectItem', $('#sources_list li')[1]);
		} else {
			$("#sources_list").jqxTree('selectItem', $('#' + _currentProjectId.toString())[0]);
		}
	});
	





})(window);