var plugins = (function() {


	// get rooth application path
	// this should be relative!!!!
	// var pluginsRoot = path.dirname(process.execPath) + "/plugins";
	var pluginsRoot = "plugins";



	function __init() {

	}


	// get array of valid plugin info object / if valid package.json file is found
	// also check for mandatory name and main fileds
	function getInstalledPluginsInfo() {

		var pluginDirs = fs.readdirSync(pluginsRoot).filter(function(file) {
			return fs.statSync(path.join(pluginsRoot, file)).isDirectory();
		});


		// get plugins info
		var pluginsInfo = [];
		var registeredNamesHelper = [];

		for (var i = 0; i < pluginDirs.length; i++) {
			var pluginPath = pluginsRoot + "/" + pluginDirs[i];

			var packagePath = pluginPath + "/package.json";

			try {
				var infoString = fs.readFileSync(packagePath, {
					encoding: "utf-8"
				});


				var infoObject = JSON.parse(infoString);

				// check if valid package
				if (!infoObject.name || !infoObject.main || infoObject.main == "" || infoObject.name == "") {
					console.log("PLUGINS - " + pluginDirs[i] + " is not a valid plugin!");
					continue;
				} 

				// check if name already exists
				else if (registeredNamesHelper.indexOf(infoObject.name) > -1) {
					console.log("PLUGINS - " + pluginDirs[i] + " - plugin with the same name is already running!");
					continue;
				}

				// check if enabled
				else if (!infoObject.enabled) {
					console.log("PLUGINS - " + pluginDirs[i] + " is disabled and will not run!");
					continue;
				}

				// add executable path into object
				infoObject["main_path"] = "./" + pluginPath + "/" + infoObject.main;


				//push into array
				pluginsInfo.push(infoObject);
				registeredNamesHelper.push(infoObject.name);

			} catch (e) {
				// no package.json file, skip this directory / mot a plugin
				console.log("PLUGINS - " + pluginDirs[i] + " - Error executing plugin! ... " + e);
				continue;
			}

		}

		return pluginsInfo;

	}






	function runInstalledPlugins() {

		var pluginsInfo = getInstalledPluginsInfo();

		for (var i = 0; i < pluginsInfo.length; i++) {
			activatePlugin(pluginsInfo[i]);
		}
	}


	function activatePlugin(pObj) {
		
		// run plugin
		try {
			_plugins[pObj.name] = require(pObj.main_path)(monkeyAPI, pObj); // 2 params to each plugin - api and plugin info
			console.log("PLUGINS - " + pObj.name + " - Loaded!");
		} catch (ex) {
			console.log(ex);
		}

		// insert options if present in package.json

		
		// run init if exists
		if (typeof _plugins[pObj.name]._init === "function") {
			_plugins[pObj.name]._init();
			console.log("PLUGINS - " + pObj.name + " - Initialized!");
		}
	}

	// cals _unplug function
	function deactivatePlugin(pObj) {

	}


	return {
		activatePlugin: activatePlugin,
		deactivatePlugin: deactivatePlugin,
		runInstalledPlugins: runInstalledPlugins
	};

})();




/*
########   ##          ######            ###     ########   ####  
##     ##  ##         ##    ##          ## ##    ##     ##   ##   
##     ##  ##         ##               ##   ##   ##     ##   ##   
########   ##         ##   ####       ##     ##  ########    ##   
##         ##         ##    ##        #########  ##          ##   
##         ##         ##    ##        ##     ##  ##          ##   
##         ########    ######         ##     ##  ##         ####  
*/


var monkeyAPI = (function(window) {

	// API 



	return {
		window: window,
		editor: window._editor,
		base: window.wm,
		storage: window.storage,
		commandPalette: window.commandPalette
	
	};

})(window);