var repository = (function() {

	var isMac = (os.platform() === 'darwin');
	var ctrl = (isMac) ? 'altKey' : 'ctrlKey';

	var heightNormal = 51;
	var heightExtended = 405;

	
	var collectionRepo;
	setRepoCollection();

	var isSearch = false;
	var elementDragged = null;
	var repoSearchTimer = null;
	var selectedItem = null;


	function setRepoCollection() {
		var db = storage.getDb();
		collectionRepo = db.collection(_settings.data_file_name + "_repository");
	}


	function __initRepo() {

		universalPane.registerPane("wm_repo", "Repository", {
			// backgroundColor: "#CCCCCC",
			width: 300,
			overflow: "hidden"
		});

		// add containers
		$("#wm_repo").append('<div id="repo_tools" style="background-color: transparent; width: 100%; height: 1.1rem;  margin-bottom: 7px;"></div>');
		$("#wm_repo").append('<div id="repo_container" style="position: relative; -webkit-box-sizing: border-box; padding-left: 5px; padding-right: 5px; height: calc(100vh - 4rem); width: calc(100% - 0px); background-color: transparent; overflow: auto;"></div>');

		if (os.platform() != 'darwin') {
			$('#repo_container').perfectScrollbar({
				suppressScrollX: true
			});
		}


		// add search input field
		$("#repo_tools").append('<input type="text" id="repo_search" placeholder="<search all>" value="" ondrop="return false;" style="width: 95%; margin-left: 7px; border: 0; color: inherit!important; background: transparent;  outline: none;">');



		$('#repo_search').on('input', function() {
			if (repoSearchTimer) window.clearTimeout(repoSearchTimer);
			repoSearchTimer = setTimeout(function() {
				getRepoItems(_currentId);
			}, 500);
		});

		$('#repo_search').on('contextmenu', function(e) {
			getShowSubmenu().popup(e.originalEvent.clientX, e.originalEvent.clientY + 10);
		});


		/*
		########      ###     ########    ######    ########   ########        ########   ##     ##  
		   ##        ## ##    ##     ##  ##    ##   ##            ##           ##         ##     ##  
		   ##       ##   ##   ##     ##  ##         ##            ##           ##         ##     ##  
		   ##      ##     ##  ########   ##   ####  ######        ##           ######     ##     ##  
		   ##      #########  ##   ##    ##    ##   ##            ##           ##          ##   ##   
		   ##      ##     ##  ##    ##   ##    ##   ##            ##           ##           ## ##    
		   ##      ##     ##  ##     ##   ######    ########      ##           ########      ###     
		*/

		var target = document.querySelector("#repo_container");


		target.addEventListener('contextmenu', function(e) {
			getItemMenu(-1).popup(e.x, e.y + 10);
		}, false);

		target.addEventListener('drop', function(e) {

			// don't do anything if existing snippet is dropped on canvas
			if (elementDragged != null) {
				return e;
			}

			// if file
			if (e.dataTransfer.files.length > 0) {
				if (e.dataTransfer.files[0].type == "text/plain") {
					var text = fs.readFileSync(e.dataTransfer.files[0].path, {
						encoding: "utf-8"
					});
					insertNewRepoItem(text, {});
				} else {
					return;
				}
			// is text from editor
			} else {
				var text = e.dataTransfer.getData('text');
				insertNewRepoItem(text, {});
				// remove source if action is move
				if (!e[ctrl]) {
					_editor.replaceSelection("");
				}
			}
		}, false);


		// if you want drag to fire!!!!
		target.addEventListener('dragover', function(e) {
			e.preventDefault();
			e.dataTransfer.effectAllowed = "copyMove";

		}, false);

		target.addEventListener('dragenter', function(e) {
			e.dataTransfer.effectAllowed = "copyMove";
		}, false);

		// set flags that text from editor is dragging
		// _editor.on("dragstart", function(cm, e) {});

		// _editor.on("dragend", function(cm, e) {});

		// _editor.on("dragenter", function(cm, e) {
		// 	if (elementDragged != null) {
		// 		// setTimeout(function(){ _editor.focus(); }, 20);
		// 		// $(".CodeMirror").trigger("click");
		// 		// _editor.focus();
		// 		// _editor.refresh();
		// 	}	
		// });

		_editor.on("drop", function(cm, e) {
			if (elementDragged != null) {
				e.codemirrorIgnore = true;

				var xy = {
					"left": e.x,
					"top": e.y
				};
				var newPos = cm.coordsChar(xy);


				cm.operation(function() {
					cm.setCursor(newPos);
					cm.replaceSelection(e.dataTransfer.getData("text"), "around");

					if (!e.shiftKey) {
						cm.execCommand("collapseSelection");
					}
				});

				if (!e[ctrl]) {
					deleteRepoItem($(elementDragged).data()._id);
				}

				cm.focus();
			}
		});



		// on document load / change
		_editor.on("swapDoc", function(e) {
			setTimeout(function() { getRepoItems(_currentId) }, 1);

		});


	}


	function toggleEmptyLabel(isVisible) {
		if (isVisible) {

			var m1 = (isSearch) ? "No matches" : "Empty";
			var m2 = (isSearch) ? "" : "Drag snippets of text here.";

			$("#repo_container").append(`<div id="repo_empty_label" style="display: block; width: 100%; margin-top: 200px; font-size: .9rem; text-align: center; opacity: .5;">${m1}<br><span style="font-size: .7rem;">${m2}</span></div>`);
			// if (!isSearch) $("#repo_search").hide();
		} else {
			$("#repo_empty_label").remove();
			// $("#repo_search").show();
		}
	}


	/*
	 #######   ##     ##  ########   ########   ##    ##   
	##     ##  ##     ##  ##         ##     ##   ##  ##    
	##     ##  ##     ##  ##         ##     ##    ####     
	##     ##  ##     ##  ######     ########      ##      
	##  ## ##  ##     ##  ##         ##   ##       ##      
	##    ##   ##     ##  ##         ##    ##      ##      
	 ##### ##   #######   ########   ##     ##     ##      
	*/
	function getRepoItems(docId) {

		var query = {};
		query.$and = {};
		query.$or = [];

		var searchString = "";
		var subSearchString = "";


		

		// // if search string, search all snippets, not just local
		// if ($('#repo_search').val().length > 0) {
		// 	searchString = $('#repo_search').val().replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
		// 	isSearch = true;
			
		// 	// if filter string is * show all snippets
		// 	if (searchString.startsWith("\\*")) {
		// 		if (searchString.trim() == "*") {
		// 			searchString = ".+";
		// 		} else {
		// 			subSearchString = searchString.substring(2).trim();
		// 		}
		// 	} 
		// 	// if filter string is $ show all expandable snippets
		// 	else if (searchString.startsWith("\\$")) {
		// 		query.$and["typ"] =	"replacement";
		// 		subSearchString = searchString.substring(2).trim();
		// 	} 
		// 	// if filter string is @ show all links and macros
		// 	else if (searchString.startsWith("\@")) {
		// 		query.$or.push({typ: "link"});
		// 		query.$or.push({typ: "macro"});
		// 		subSearchString = searchString.substring(1).trim();

		// 	} 
		// 	// if filter string is ! show all pictures
		// 	else if (searchString.startsWith("\!")) {
		// 		query.$and["typ"] =	"picture";
		// 		subSearchString = searchString.substring(1).trim();

		// 	} 
		// 	// if filter string is % show all project's snippets
		// 	else if (searchString.startsWith("\%") && _currentProjectId != -1) {
		// 		query.$and["gid"] = _currentProjectId;
		// 		subSearchString = searchString.substring(1).trim();
		// 	}

		// 	// if filter string is = show all project's snippets + global
		// 	else if (searchString.startsWith("\=") && _currentProjectId != -1) {
		// 		subSearchString = searchString.substring(1).trim();
		// 		query.$or.push({
		// 			gid: _currentProjectId
		// 		});
		// 		query.$or.push({
		// 			isg: true
		// 		});
		// 	}


		// if search string, search all snippets, not just local
		if ($('#repo_search').val().length > 0) {
			searchString = $('#repo_search').val().replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
			isSearch = true;

			// if filter string is * show all snippets
			if (searchString.startsWith("@all")) {
				if (searchString.trim() == "*") {
					searchString = ".+";
				} else {
					subSearchString = searchString.substring(4).trim();
				}
			}
			// if filter string is $ show all expandable snippets
			else if (searchString.startsWith("@exp")) {
				query.$and["typ"] = "replacement";
				subSearchString = searchString.substring(4).trim();
			}
			// if filter string is @ show all links and macros
			else if (searchString.startsWith("@macro")) {
				query.$or.push({
					typ: "link"
				});
				query.$or.push({
					typ: "macro"
				});
				subSearchString = searchString.substring(6).trim();

			}
			// if filter string is ! show all pictures
			else if (searchString.startsWith("@img")) {
				query.$and["typ"] = "picture";
				subSearchString = searchString.substring(4).trim();

			}

			// if filter string is = show all project's snippets + global
			else if (searchString.startsWith("@project") && _currentProjectId != -1) {
				subSearchString = searchString.substring(8).trim();
				query.$or.push({
					gid: _currentProjectId
				});
				query.$or.push({
					isg: true
				});
			}


			// string search
			else {
				query.$and["txt"] = {
					$regex: searchString,
					$options: 'gi'
				};
			}

			// add sub search string if provided
			if (subSearchString.length >= 1) {
				query.$and["txt"] = {
					$regex: subSearchString,
					$options: 'gi'
				};
			}

		} else { // empty search string, just show default
			isSearch = false;
			query.$or.push({
				did: docId
			});
			query.$or.push({
				isg: true
			});
		}
		

		collectionRepo
			.find(query)
			.sort({
				ord: -1
			})
			.limit(10000)
			.toArray(function(err, arr) {
				// assert.equal(null, err);
				$("#repo_container").html("");
				toggleEmptyLabel(arr.length <= 0);
				_currentRepoList = arr;
				setRepoHTML(arr);
			});
	}


	function setRepoHTML(items) {

		var repoHTML = "";
		$('#repo_tools').show();
		

		// $("#repo_container").css("display", "none");


		// $('#repo-container').hide();
		for (var i = 0; i < items.length; i++) {

			// append item to dom
			var itemObject = getItemDomObject(items[i]);
			$("#repo_container").append(itemObject);


			/*
			########   ##         ##     ##       ########   ##     ##  
			##         ##         ###   ###       ##         ##     ##  
			##         ##         #### ####       ##         ##     ##  
			######     ##         ## ### ##       ######     ##     ##  
			##         ##         ##     ##       ##          ##   ##   
			##         ##         ##     ##       ##           ## ##    
			########   ########   ##     ##       ########      ###     
			*/
			var el = document.getElementById("repo" + items[i]._id);



			el.addEventListener('drop', function(e) {


				// if source is another snippet, stop propagation, reorder
				if (elementDragged != null) {
					e.stopPropagation();
					e.preventDefault();
					var source = $(elementDragged).data();
					var target = $(this).data();

					if (source._id == target._id) return;


					// console.log('Source: ', source );
					// console.log('Prev: ', $(this).prev().data() );
					// console.log('Next: ', $(this).data() );

					// get order from previous
					var prevOrd = new Date().getTime(); // if 0 (to top)
					if (  $(this).prev() && $(this).prev().data() && $(this).prev().data().ord   ) {
						prevOrd = $(this).prev().data().ord;
					}

					// get order from next
					var nextOrd = 0; // if last (to bottom)
					if (  $(this).data()  ) {
						nextOrd = $(this).data().ord;
					}

					var newOrd = prevOrd - ((prevOrd - nextOrd) / 2);
					source.ord = newOrd;

					// var diff = (source.ord > target.ord) ? -100 : 100;
					// source.ord = target.ord + diff;

					updateRepoItem(source, true);
				}
			}, false);


			// add events
			el.addEventListener('dragstart', function(e) {
				elementDragged = this;
				e.dataTransfer.effectAllowed = "copyMove";
				e.dataTransfer.setData("text/plain", $(this).data("txt"));
			}, false);


			el.addEventListener('dragend', function(e) {
				elementDragged = null;
			}, false);

			el.addEventListener('dragover', function(e) {
				e.preventDefault();
			}, false);

			el.addEventListener('dblclick', function(e) {
				e.stopPropagation();

				var obj = $(this).data();
				obj.hgh = (obj.hgh > heightNormal) ? heightNormal : heightExtended;
				updateRepoItem(obj, true);

			}, false);

			// el.addEventListener('mousedown', function(e) {
			// 	if (e.button == 0) $(this).css("transform", "translate(-2px, -2px)");
			// }, false);

			// el.addEventListener('mouseup', function(e) {
			// 	if (e.button == 0) $(this).css("transform", "none");
			// }, false);


			el.addEventListener('click', function(e) {

				if (elementDragged == null && e.button == 0) {
					e.stopPropagation();
					e.preventDefault();


					if (e.ctrlKey || e.metaKey) {
						expandRepoItem($(this).data());
						return;
					}

					if ($(this).data().typ == "link") {
						$(this).fadeOut(30).fadeIn(30);
						opener(getUrlLink($(this).data().txt));
						return;
					} else if ($(this).data().typ == "macro") {
						$(this).fadeOut(30).fadeIn(30);
						runMacro($(this).data().txt);
						return;
					}

					// scroll content if expanded
					if ($(this).data().hgh > heightNormal) {
						var parentNode = "#repo" + $(this).data()._id.toString();
						var parentHeight = $(parentNode).height();
						var scrollAmount = parentHeight - 50 + "px";
						var scrollDir = (e.layerY <= parentHeight / 2) ? "-=" : "+="
						// console.log(scrollDir);	

						$(parentNode + " .repoLabel").scrollTo(scrollDir + scrollAmount, {
							axis: 'y',
							duration: 300
						});
					}
				}

			}, false);

			el.addEventListener('contextmenu', function(e) {
				e.stopPropagation();
				getItemMenu($(this).data()._id).popup(e.x, e.y + 10);
			}, false);

			el.addEventListener('mouseover', function(e) {
				$(this).css("-webkit-filter", "brightness(.9)");
				selectedItem = this;
			}, false);

			el.addEventListener('mouseout', function(e) {
				$(this).css("-webkit-filter", "none");
			}, false);
			
		}
		// $('#repo_container').fadeIn(100);


	}

	/*
	####  ########   ########   ##     ##       ##     ##  ########   ##    ##   ##     ##  
	 ##      ##      ##         ###   ###       ###   ###  ##         ###   ##   ##     ##  
	 ##      ##      ##         #### ####       #### ####  ##         ####  ##   ##     ##  
	 ##      ##      ######     ## ### ##       ## ### ##  ######     ## ## ##   ##     ##  
	 ##      ##      ##         ##     ##       ##     ##  ##         ##  ####   ##     ##  
	 ##      ##      ##         ##     ##       ##     ##  ##         ##   ###   ##     ##  
	####     ##      ########   ##     ##       ##     ##  ########   ##    ##    #######   
	*/
	function getItemMenu(id) {

		// if id is -1 just show item non specific items
		var itemObject = (id == -1) ? getNewRepoDbObject("", -1) : $(document.getElementById("repo" + id)).data();

		var itemMenu = new gui.Menu({
			'type': 'menubar'
		});

		var deleteMenuItem = new gui.MenuItem({
			label: "Delete",
			type: "normal",
			click: function() {
				deleteRepoItem(id);
			}
		});
		var newMenuItem = new gui.MenuItem({
			label: "New",
			type: "normal",
			click: function() {
				insertNewRepoItem("", {});
			}
		});

		var pasteMenuItem = new gui.MenuItem({
			label: "New from clipboard",
			type: "normal",
			click: function() {
				var clipboard = gui.Clipboard.get();
				insertNewRepoItem(convertLink(clipboard.get('text')), {});
			}
		});

		var copyMenuItem = new gui.MenuItem({
			label: "Copy snippet",
			type: "normal",
			click: function() {
				var clipboard = gui.Clipboard.get();
				clipboard.set(itemObject.txt, 'text');
			}
		});


		var cutMenuItem = new gui.MenuItem({
			label: "Cut snippet",
			type: "normal",
			click: function() {
				var clipboard = gui.Clipboard.get();
				clipboard.set(itemObject.txt, 'text');
				deleteRepoItem(id);
			}
		});

		var moveToDocMenuItem = new gui.MenuItem({
			label: "Move to document",
			type: "normal",
			click: function() {
				_editor.replaceSelection(itemObject.txt, "around");
				_editor.execCommand("collapseSelection");
				
				deleteRepoItem(id);
			}
		});


		var isGlobalMenuItem = new gui.MenuItem({
			label: itemObject.isg ? "Set as local" : "Set as global",
			type: "normal",
			click: function() {
				itemObject.did = itemObject.isg ? _currentId : itemObject.did;
				itemObject.isg = !itemObject.isg;
				updateRepoItem(itemObject, true);
			}
		});

		var biggerMenuItem = new gui.MenuItem({
			label: (itemObject.hgh > heightNormal) ? "Make smaller" : "Make bigger",
			type: "normal",
			click: function() {
				itemObject.hgh = (itemObject.hgh > heightNormal) ? heightNormal : heightExtended;
				updateRepoItem(itemObject, true);
			}
		});


		var doneMenuItem = new gui.MenuItem({
			label: (itemObject.isd ? "Remove strikethrough" : "Strikethrough"),
			type: "normal",
			click: function() {
				itemObject.isd = !itemObject.isd;
				updateRepoItem(itemObject, true);
			}
		});


		var marksSubmenu = new gui.Menu();


		var colors = _settings["repo_item_colors"];

		for (var i = 0; i < colors.length; i++) {
			marksSubmenu.append(new gui.MenuItem({
				label: colors[i].name,
				tooltip: colors[i].color,
				click: function() {
					itemObject.mrk = this.tooltip;
					updateRepoItem(itemObject, true);
				}
			}));
		}



		var markMenuItem = new gui.MenuItem({
			label: "Mark with color",
			type: "normal",
			submenu: marksSubmenu
		});


		var showTextMenuItem = new gui.MenuItem({
			label: "Edit",
			type: "normal",
			click: function() {
				expandRepoItem(itemObject);
			}
		});


		var showOnlyMenuItem = new gui.MenuItem({
			label: "Show",
			type: "normal",
			submenu: getShowSubmenu()
		});



		id != -1 && itemMenu.append(markMenuItem);
		id != -1 && itemMenu.append(doneMenuItem);
		id != -1 && itemMenu.append(biggerMenuItem);
		id != -1 && itemMenu.append(isGlobalMenuItem);
		id != -1 && itemMenu.append(new gui.MenuItem({
			type: "separator"
		}));
		id != -1 && itemMenu.append(copyMenuItem);
		id != -1 && itemMenu.append(cutMenuItem);
		id != -1 && itemMenu.append(moveToDocMenuItem);
		id != -1 && itemMenu.append(showTextMenuItem);
		id != -1 && itemMenu.append(deleteMenuItem);
		id != -1 && itemMenu.append(new gui.MenuItem({
			type: "separator"
		}));
		itemMenu.append(newMenuItem);
		itemMenu.append(pasteMenuItem);
		itemMenu.append(showOnlyMenuItem);

		return itemMenu;
	}



	function getShowSubmenu() {

		var showSubmenu = new gui.Menu();

		showSubmenu.append(new gui.MenuItem({
			label: "Current document (default)",
			click: function() {
				$("#repo_search").val(""); getRepoItems(_currentId);
			}
		}));



		showSubmenu.append(new gui.MenuItem({
			label: "Current project",
			enabled: _currentProjectId != -1,
			click: function() {
				$("#repo_search").val("@project");
				getRepoItems(_currentId);
			}
		}));

	
		showSubmenu.append(new gui.MenuItem({
			label: "Macros & Links",
			click: function() {
				$("#repo_search").val("@macro"); getRepoItems(_currentId);
			}
		}));

		showSubmenu.append(new gui.MenuItem({
			label: "Expandable snippets",
			click: function() {
				$("#repo_search").val("@exp");
				getRepoItems(_currentId);
			}
		}));

		showSubmenu.append(new gui.MenuItem({
			label: "Images",
			click: function() {
				$("#repo_search").val("@img");
				getRepoItems(_currentId);
			}
		}));

		showSubmenu.append(new gui.MenuItem({
			label: "All snippets",
			click: function () {
				$("#repo_search").val("@all");
				getRepoItems(_currentId);
			}
		}));

		return showSubmenu;
	}



	function getItemDomObject(obj) {
		
		var itemHeight = obj.hgh;

		var tile_class;
		switch (obj.typ) {
			case "macro":
			case "link":
				tile_class = "wm-repo-clickable";
				itemHeight = 13;
				break;
			case "comment":
				tile_class = "wm-repo-comment";
				break;
			default:
				tile_class = "wm-repo-tile";
		}

		var $itemHtml = $("<div>", {
				id: "repo" + obj._id,
				class: "repository-item",
				draggable: "true"
			}).css({
				"position": "relative",
				"overflow": "hidden",
				"font-size": itemHeight > heightNormal ? ".85rem" : ".83rem",
				"font-weight": "normal",
				// "background-color": itemBgColor,
				"text-decoration": obj.isd ? "line-through" : "none",
				// "color": itemColor,
				"height": (itemHeight / 16).toString() + "rem", // hack
				"margin-bottom": "5px",
				"padding": "7px",
				"border-left": obj.mrk != "transparent" ? ".3rem solid " + obj.mrk : "0rem solid transparent",
				// "border-left": obj.isg ? "0rem solid #000000" : "0rem solid transparent",
				"border-radius": ".2rem",
				// "border-top-right-radius": obj.isg ? "8px" : "2px",
				"background-image": obj.typ == "picture" ? 'url(' + getPictureLink(obj.txt) + ')' : "",
				"background-size": "cover", // obj.hgh > heightNormal ? "contain" : 
				"background-repeat": "no-repeat",
				"background-position": "center center",
				"cursor": obj.typ == "link" || obj.typ == "macro" ? "pointer" : "default"
				// "-webkit-user-select": "text"
			})
			.html(`<div class="repoLabel" style=" height: calc(${obj.hgh / 16}rem - 1.2rem); line-height: 1rem; margin-bottom: 6px; word-wrap: break-word; position: relative; overflow: hidden;">` + getLabelText(obj) + '</div>')
			.data(obj);

		$itemHtml.addClass(tile_class);

		// var sameProj = "";
		// if (_currentProjectId != -1 && _currentProjectId == obj.gid && _currentId != obj.did) {
		// 	sameProj = 'project &nbsp;&nbsp;&#8226;&nbsp;&nbsp;';
		// }


		var $itemInfo = $("<span>", {
				id: "repoInfo" + obj._id,
			}).css({
				
				"float": "left",
				"overflow": "hidden",
				"white-space": "nowrap",
				"font-size": ".7rem",
				"text-align": "left",
				"font-weight": "normal",
				// "background-color": "rgba(10, 10, 10, 0)",
				// "color": tinycolor(itemColor).setAlpha(.6),
				"padding": "2px 5px 1px 0px",
				"border-radius": "2em",
				"opacity": ".6"
			})
			.html(obj.wrd + ' words&nbsp;&nbsp;&#8226;&nbsp;&nbsp;' + moment(obj.dtc).fromNow(false) + '' + (obj.isg ? "&nbsp;&nbsp;&#8226;&nbsp;&nbsp;global" : ""));

		if (obj.typ != "picture" && obj.typ != "macro") $itemHtml.append($itemInfo);

		return $itemHtml;
	}



	function getLabelText(obj) {
		var txt = obj.txt;
		var max = 500;

		if (txt.length == 0) {
			txt = '<span style="opacity: .5; font-weight: bold;">Empty - ctrl click to edit</span>';
			return txt;
		}

		
		if (obj.typ == "link") {
			// get link name or if absent link text
			var m = txt.match(/\[(.*)\]\((.+)\)/);
			var linkName = (m[1].length > 0) ? m[1] : m[2].slice(-35);
			return `<div style="float: right; font-size: .9rem;" class="awf">&#xf08e;</div><div style="width: calc(100% - 1rem); white-space: nowrap; font-size: .85rem; text-align: left; overflow: hidden;">${linkName}</div>`;
		} 

		else if (obj.typ == "macro") {

			var mm = txt.match(/\/\*(.+)*?\*\//);
			var macroName = (mm && mm[1]) ? mm[1] : "wrong name";
			return `<div style="float: right; font-size: .9rem;" class="awf">&#xf12e;</div><div style="width: calc(100% - 1rem); white-space: nowrap; text-align: left; font-size: .85rem; overflow: hidden;">${macroName}</div>`;

		} 

		else if (obj.typ == "replacement") {
			var mmm = txt.match(/^{(.+)}/);
			var replName = ((mmm && mmm[1]) ? mmm[1] : "wrong trigger");
			var replBody = obj.txt.replace(/^{.+}\s*/, "");
			txt = '<div style="cursor: default; float: right; font-size: .85rem;" class="awf">&#xf0e7;</div><div style="width: calc(100% - 18px);"><strong>' + replName + '</strong>\n\n ' + replBody + '</div>'; 
		}


		else if (obj.typ == "comment") {

			txt = txt.trim().replace(/^\/\//, "");
		} 


		else if (txt.startsWith("![")) {
			return "";
		}



		// if (txt.startsWith("#")) {
		var regexp = new RegExp("^(#{1,6}.+\n+)", 'i');
		txt = txt.replace(regexp, '<span style="white-space: nowrap; font-weight: bold; font-size: 1rem">$1</span>');
		// }

		if (obj.hgh > heightNormal) {
			txt = txt.replace(/\n/gi, "<br>");
		} else {
			txt = txt.substring(0, max);
		}

		return txt;
	}


	function getType(txt) {
		txt = txt.trim();
		var type = "snippet";

		type = (/^\/\*.+\*\//.test(txt)) ? "macro" : type;
		type = (/^{.+}/.test(txt)) ? "replacement" : type;
		type = (txt.startsWith("//")) ? "comment" : type;
		type = (getPictureLink(txt).length > 0) ? "picture" : type;
		type = (getUrlLink(txt).length > 0) ? "link" : type;
		return type;
	}


	function getPictureLink(text) {
		var m = text.match(/^!\[.*?\]\((.*?)\)/);
		if (m && m[1]) return m[1].replace(/\\/g, "/");
		return "";
	}

	function getUrlLink(text) {
		var m = text.match(/^\[.*?\]\((.*?)\)/);
		if (m && m[1]) return m[1];
		return "";
	}



	function extractLink(text) {
		var m = text.match(/^((https?|file|ftp):\/\/(?:www\.|(?!www))[^\s\.]+\.[^\s]{2,}|www\.[^\s]+\.[^\s]{2,})$/i);
		if (m && m[0]) {
			// console.log(m);
			return m[0].replace(/\\/g, "/");
		}
		return "";
	}


	function convertLink(text) {
		var l = extractLink(text);
		var regexp = new RegExp("jpg|jpeg|gif|png$", 'i');
		if (l && regexp.test(l)) {
			return "![](" + l + ")";
		} else if (l) {
			return "[](" + l + ")";
		}
		return text;
	}


	function getNewRepoDbObject(text, docId) {

		var type = getType(text);
		// var count = type == "comment" ? text.match(/\S+/g).length : stats.getWords(text).count;
		var count = stats.getWords(text.replace(/^\/\//, "")).count;

		return {
			did: docId,
			gid: _currentProjectId,
			dtc: (new Date().getTime()),
			dtm: -1,
			ord: (new Date().getTime()),
			mrk: "transparent",
			typ: type,
			hgh: heightNormal,
			siz: 14,
			isg: false,
			isd: false,
			wrd: count,
			txt: text
		};
	}


	/*
	########   ##     ##  ########      ###     ##    ##   ########   
	##          ##   ##   ##     ##    ## ##    ###   ##   ##     ##  
	##           ## ##    ##     ##   ##   ##   ####  ##   ##     ##  
	######        ###     ########   ##     ##  ## ## ##   ##     ##  
	##           ## ##    ##         #########  ##  ####   ##     ##  
	##          ##   ##   ##         ##     ##  ##   ###   ##     ##  
	########   ##     ##  ##         ##     ##  ##    ##   ########   
	*/
	function expandRepoItem(obj) {

		// hide all 
		$('.repository-item').hide();
		$('#repo_tools').hide();

		var $itemTextarea = $("<textarea>", {
			id: "repoTextarea",
			class: "repository-textarea",
			draggable: "false"
		}).attr({
			// "wrap": "soft"
		}).css({
			"position": "relative",
			"overflow": "auto",
			"display": "block",
			// "-webkit-box-sizing": "border-box",
			"font-family": "Hack Mono",
			"font-size": ".7rem",
			"line-height": "150%",
			"font-weight": "normal",
			"background-color": "transparent",
			"padding-right": "0px",
			"padding-left": "5px",
			"margin": "0px",
			"border": "none",
			"outline": "none",
			"color": "inherit",
			"height": "99%",
			"width": "100%",
			"resize": "none"
		});

		function saveTextAreaAndExit() {
			obj.txt = $itemTextarea.val();
			obj.typ = getType(obj.txt);
			obj.wrd = stats.getWords(obj.txt.replace(/^\/\//, "")).count;
			updateRepoItem(obj, true);
		}

		$("#repo_container").append($itemTextarea);
		$itemTextarea.val(obj.txt);
		$itemTextarea.setCursorPosition(0);
		$itemTextarea.focus();


		// add events
		$itemTextarea.on("click", function(e) {
			if (e.ctrlKey || e.metaKey) {
				saveTextAreaAndExit();
			}
		});

		$itemTextarea.on('contextmenu', function(e) {
			e.preventDefault();
			e.stopPropagation();
			console
			var exitMenu = new gui.Menu({
				'type': 'menubar'
			});
			exitMenu.append(new gui.MenuItem({
				label: 'Save & close',
				click: function() {
					saveTextAreaAndExit();
				}
			}));
			exitMenu.popup(e.originalEvent.x, e.originalEvent.y + 10);
		});


		$itemTextarea.on("blur", function(e) {
			obj.txt = $itemTextarea.val();
			obj.typ = getType(obj.txt);
			updateRepoItem(obj, false);
		});

		$itemTextarea.on("keydown", function(e) {
			if ((e.ctrlKey || e.metaKey) && e.keyCode == 13) {
				saveTextAreaAndExit();
			}
		});
	}



	/*
	####  ##    ##    ######    ########   ########   ########   
	 ##   ###   ##   ##    ##   ##         ##     ##     ##      
	 ##   ####  ##   ##         ##         ##     ##     ##      
	 ##   ## ## ##    ######    ######     ########      ##      
	 ##   ##  ####         ##   ##         ##   ##       ##      
	 ##   ##   ###   ##    ##   ##         ##    ##      ##      
	####  ##    ##    ######    ########   ##     ##     ##      
	*/
	function insertNewRepoItem(text, options) {
		repoOject = getNewRepoDbObject(text, _currentId);
		collectionRepo.insert(repoOject, function(err, result) {
			// assert.equal(err, null);
			// console.log(repoOject);

			// reload list
			getRepoItems(_currentId);
		});
	}



	/*
	##     ##  ########   ########      ###     ########   ########   
	##     ##  ##     ##  ##     ##    ## ##       ##      ##         
	##     ##  ##     ##  ##     ##   ##   ##      ##      ##         
	##     ##  ########   ##     ##  ##     ##     ##      ######     
	##     ##  ##         ##     ##  #########     ##      ##         
	##     ##  ##         ##     ##  ##     ##     ##      ##         
	 #######   ##         ########   ##     ##     ##      ########   
	*/
	function updateRepoItem(newObject, reloadAfterUpdate) {
		collectionRepo.update({
			_id: newObject._id
		}, newObject, function(err, numberOfUpdatedDocs) {

			// reload list if needed
			if (reloadAfterUpdate)
				getRepoItems(_currentId);
		});
	}



	/*
	########   ########   ##         ########   ########   ########   
	##     ##  ##         ##         ##            ##      ##         
	##     ##  ##         ##         ##            ##      ##         
	##     ##  ######     ##         ######        ##      ######     
	##     ##  ##         ##         ##            ##      ##         
	##     ##  ##         ##         ##            ##      ##         
	########   ########   ########   ########      ##      ########   
	*/
	function deleteRepoItem(id) {

		$(selectedItem).fadeOut(500, function() {
			collectionRepo.remove({
				_id: id
			}, {}, function(err, numberOfRemovedDocs) {

				// reload list
				getRepoItems(_currentId);
			});
		});		
	}



	__initRepo();


	/*
	##     ##     ###      ######    ########    #######   
	###   ###    ## ##    ##    ##   ##     ##  ##     ##  
	#### ####   ##   ##   ##         ##     ##  ##     ##  
	## ### ##  ##     ##  ##         ########   ##     ##  
	##     ##  #########  ##         ##   ##    ##     ##  
	##     ##  ##     ##  ##    ##   ##    ##   ##     ##  
	##     ##  ##     ##   ######    ##     ##   #######   
	*/
	function runMacro(code) {
		
		try {
			var context = new vm.createContext(window);
			var script = new vm.Script(code);
			script.runInContext(context);
		} catch (ex) {
			wm.showNotice("Error runnig macro!");
			console.log(ex);
		}
	}


	/*
	########   ########   ########   ##            ###      ######    
	##     ##  ##         ##     ##  ##           ## ##    ##    ##   
	##     ##  ##         ##     ##  ##          ##   ##   ##         
	########   ######     ########   ##         ##     ##  ##         
	##   ##    ##         ##         ##         #########  ##         
	##    ##   ##         ##         ##         ##     ##  ##    ##   
	##     ##  ########   ##         ########   ##     ##   ######    
	*/
	function setReplacementFromTrigger() {

		var w = _editor.findWordAt(_editor.getCursor());
		var q = _editor.getRange(w.from(), w.to());


		// easter eggs
		switch (q) {
			case "sprinkler":
				_editor.setOption("blastCode", !_editor.getOption("blastCode"));
				_editor.replaceRange("", w.from(), w.to());
				return;
			case "sprinkler2":
				_editor.setOption("blastCode", !_editor.getOption("blastCode") ? {effect: 2} : false);
				_editor.replaceRange("", w.from(), w.to());

			default:
		}
		

		var query = {};
		query.$and = {};
		query["typ"] = "replacement";
		query.$and["txt"] = {
				$regex: '^{' + q + '}',
				$options: 'i'
		};

		collectionRepo
			.find(query)
			.limit(1)
			.toArray(function(err, arr) {
				if (arr.length > 0) {
					_editor.replaceRange("", w.from(), w.to());
					_editor.replaceSelection(arr[0].txt.replace(/^{.+}\s*\n*/, "")
						.replace(/\[date\]/g, moment().format(_settings.expand_datetime_format))
						.replace(/\[clipboard\]/g, gui.Clipboard.get().get('text'))
						);
				}
			});
	}


	function getRepoPaletteItems() {

		var itemsA = _currentRepoList;
		var paletteA = [];

		for (var i = 0; i < itemsA.length; i++) {

			var ob = itemsA[i];
			var label = ob.txt;
			if (label.length <= 0 || ob.typ == "replacement") continue;
			var icon = '&#xf249;';
			var widgetText = "";
			
			switch (ob.typ) {
				case "macro":
					widgetText = "run macro";
					label = label.match(/\/\*(.+)*?\*\//)[1];
					break;
				case "link":
					widgetText = "open link";
					label = label.match(/\[(.*)\]\((.+)\)/)[1];
					break;
				case "comment":
					widgetText = "copy text";
					label = label.trim().replace(/^\/\//, "");
					break;
				default: // copy text
					widgetText = "copy text";
					break;
			}

			paletteA.push({
				id: '',
				string: label.substring(0, 60),
				shortcut: moment(ob.dtc).fromNow(true),
				action: 'repository.processRepositoryItem( ' + i + '  )',
				type: "eval",
				sublist: [],
				persist: false,
				icon: '<span style="margin-right: 5px; color: '+ ob.mrk +'" class="awf">' + icon + '</span>',
				widget: {
					type: "eval",
					value: '"' + widgetText + '"'
				}
			});
		}

		return paletteA;
	}


	function processRepositoryItem(index) {
		
		var ob = _currentRepoList[index];

		switch (ob.typ) {
			case "macro":
				runMacro(ob.txt);
				break;
			case "link":
				opener(getUrlLink(ob.txt));
				break;
			default: // copy text
				var clipboard = gui.Clipboard.get();
				clipboard.set(ob.txt, 'text');
				break;
		}
	}


	


	/*
	   ###     ########   ####  
	  ## ##    ##     ##   ##   
	 ##   ##   ##     ##   ##   
	##     ##  ########    ##   
	#########  ##          ##   
	##     ##  ##          ##   
	##     ##  ##         ####  
	*/

	return {
		insertNewRepoItem: insertNewRepoItem,
		setReplacementFromTrigger: setReplacementFromTrigger,
		setRepoCollection: setRepoCollection,
		getRepoPaletteItems: getRepoPaletteItems,
		processRepositoryItem: processRepositoryItem
	};

})();
/* EOF */