var wisdom = (function() {


	function getRandomLineFromFile() {
		try {
			var s = fs.readFileSync('core/modules/wisdom/wisdom.txt', 'utf8');
		} catch (e) {
			console.log(e);
			return "Wisdom not available right now!"
		}
		var sa = _s.lines(s);
		var ri = Math.floor(Math.random() * sa.length);
		return sa[ri];
	}

	function getThemeColors() {
		return {
			back: localStorage["VIEWPORT_BACKGROUND_COLOR"] ? localStorage["VIEWPORT_BACKGROUND_COLOR"] : "#e3e3e3",
			text: localStorage["VIEWPORT_MARK_COLOR"] ? localStorage["VIEWPORT_MARK_COLOR"] : "#373737",
		}
	}

	function stopSpinner() {
		var sp = $("#wisdom-spinner").fadeOut('fast').fadeIn('fast');
		sp.removeAttr('id');
		sp.append('<div style="font-size:.4em; line-height:1.5em;">Ready!<br>Press any key to begin.</div>').hide();
		enableHide();
		sp.fadeTo(900, 1);
	}

	function enableHide() {

		$("body").one("keyup", function(event) {
			event.preventDefault();
			if ($("#wisdom-panel").length) {
				$("#wisdom-panel").fadeOut(250, function() {
					$("#wisdom-panel").remove();
					_editor.focus();
				});
			}
		});

		$("#wisdom-panel").one("click", function(event) {
			if ($("#wisdom-panel").length) {
				$("#wisdom-panel").fadeOut(250, function() {
					$("#wisdom-panel").remove();
					_editor.setOption("readOnly", false);
					_editor.focus();
				});
			}
		});
	}


	function showWisdom() {

		var wd = $('<div/>', {
			id: 'wisdom-panel',
			name: 'wisdom-panel',
			class: 'wisdom-panel'
		}).css({
			"display": "block",
			"contenteditable": "true",
			"background-color": getThemeColors().back,
			"cursor": "default",
			"color": getThemeColors().text,
			"-webkit-filter": localStorage["VIEWPORT_FILTERS"] ? localStorage["VIEWPORT_FILTERS"] : "",
			"opacity": "1",
			"font-family": "Hack Mono",
			"font-weight": "regular",
			"font-size": "1.6em",
			"height": "100%",
			"width": "100%",
			"line-height": "1.6em",
			"text-align": "center",
			"left": "0",
			"top": "0",
			"overflow": "hidden",
			"position": "fixed",
			"z-index": "1000"
		});

		var w = getRandomLineFromFile();
		var wcount = localStorage["STATS_LIBRARY_WORD_COUNT"] ? stats.add000separator(localStorage["STATS_LIBRARY_WORD_COUNT"]) : "0";

		wd.append('<div style="font-family: Hack Mono; position: fixed; padding-right: 15px; bottom: -.4rem; right: 0px; font-size: .5em; ">' + app.manifest.releaseDate + " - " + app.manifest.version + ' - <span id="release-name">' + app.manifest.releaseName + '</span></div>');


		wd.append('<p id="wisdom" style="cursor: pointer; margin: 20%; margin-top: calc(100vh / 3.5); margin-bottom: 17px;">' + w + '</p>');

		wd.append('<p id="wisdom-footer" style="font-size: 0.55em; font-style: italic;">&nbsp;</p>');


		var k = wm.ckk();
		var n = k != -1 ? k : "Anonymous";
		wd.append('<div style="font-family: Hack Mono; position: fixed; padding-left: 15px; bottom: -.4rem; left: 0px; font-size: .5em; ">' + n + ' has written ' + wcount + ' words</div>');

		wd.append('<div id="wisdom-spinner" style="margin-top: 2em;"> <svg id="Layer_1" data-name="Layer 1" width="50" height="50" viewBox="0 0 948.68 956.52"> <defs> <style> .cls-1 { fill: ' + getThemeColors().text + '; } .cls-2 { fill: ' + getThemeColors().back + '; stroke: ' + getThemeColors().back + '; stroke-miterlimit: 10; stroke-width: 29px; } </style> </defs> <circle class="cls-1" cx="474.34" cy="482.18" r="474.34" transform="translate(-202.02 476.63) rotate(-45)" /> <path class="cls-2" d="M687.77,662.55,635.23,460.61c-11.49-44.32-22.17-85.37-29.55-126.41h-2.47c-9,40.22-22.16,82.91-35.3,125.59L503.06,662.55H442.32L380.75,463.9c-14.77-47.61-26.27-89.48-35.3-129.7H343c-6.57,40.22-17.24,82.09-30.37,128.88L256,662.55H184.56L312.62,265.24h65.67L439,454.87c14,44.33,25.45,83.73,35.3,130.52H476c9.85-47.61,22.16-88.66,36.11-131.34l64-188.81H641.8L761.65,662.55Z" /> </svg> </div>');

		wd.appendTo('html');
		$("#wisdom-spinner").css("border-color", getThemeColors().text);


		setTimeout(function() {
			$("#wisdom-panel").css("color", getThemeColors().text);
		}, 0);


		$("#wisdom").one("click", function(event) {
			event.stopPropagation();
			var clipboard = gui.Clipboard.get();
			clipboard.set(w, 'text');
			$("#wisdom-footer").hide().fadeIn("slow");
			$("#wisdom-footer").append("Monkey wisdom copied :)");
		});

	};




	/*
	   ###     ########   ####
	  ## ##    ##     ##   ##
	 ##   ##   ##     ##   ##
	##     ##  ########    ##
	#########  ##          ##
	##     ##  ##          ##
	##     ##  ##         ####
	*/

	return {
		showWisdom: showWisdom,
		stopSpinner: stopSpinner
	};

})();
/* EOF */