module.exports = function(api, pluginInfo) {

	var options = pluginInfo.options;
	var $ = api.window.$;
	var m = window;
	var ed = m._editor;

	var pairs = options.triggerReplacementPairs;


	function _init() {
		ed.on("keyup", function(cm, e) {
			if (e.keyCode == 32) {
				triggerReplacement();
			}
		});
	}

	function triggerReplacement() {

		var cursor = ed.getCursor();
		var textToCheck = ed.getLine(cursor.line).substring(0, cursor.ch).trim();

		var l = pairs.length;
		for (var i = 0; i < l; i++) {
			if (textToCheck.endsWith(pairs[i].t)) {
				var replaceStart = cursor.ch - pairs[i].t.length - 1;
				var replaceEnd = replaceStart + pairs[i].t.length + (pairs[i].keepSpace ? 0 : 1);
				ed.replaceRange(pairs[i].r, {line: cursor.line, ch: replaceStart}, {line: cursor.line, ch: replaceEnd});
				ed.setCursor({line: cursor.line, ch: replaceEnd + pairs[i].moveCursor});
				break;
			}
		}
	}

	return {
		_init: _init
	};
};